         ' LCD - Tastatur             05.01.2008
                 
         ' mit PIC 16 F 628(A) 
         ' ohne Relaisversatz 7,6 MHz 
         ' Ausgabe VFO-A/B
         ' Statusausgabe QRG, Betriebsart
         ' Zusatz: Mode(9), Split(8)
         ' Rcksetzen von "Lock" und "Split"
         
                 
          
         date 
         time
         
         
         define device 16f628, wdt_off, cmcfg7, lvp_off, hs_osc
         xtal 4.00                     'cmcfg7 --> alle Komparator aus
         
         
         
         define serout = soft
         define serin = soft
         
         define keys rb,0,"A","7","4","1","0","8","5",{+}
                          "2","B","9","6","3"
                          
                           
         define ta_dat  = $20           
         define o_dat1  = $21
         define o_dat2  = $22
         define o_dat3  = $23
         define o_dat4  = $24
         define o_dat5  = $25
         define spalte  = $26
         define zeile   = $27
         define sp      = $28
         define zahl    = $29
         define tmp0    = $2a
         define tmp1    = $2b
         define tmp2    = $2c
         define t_sp    = $2d
         define t_ze    = $2e        
         define wert    = $2f
         define trx     = $30
         define var     = $31
         define ba      = $32
         
         define qrg     = $40 as byte
         
         
init:    wait 1000
         tris ra=%11111101            'ra 7-2 input, ra1=out, ra0=in
         tris rb=%00001111            'rb 7-4 output, 3-0 input LCD, Tastatur
         
         lcdinit rb,2,16              ' LCD init --> zweizeilig HD44780
         lcdwrite 1,1,"FT817-Steuerung "
         wait 3000
         lcdclear
         lcdwrite 1,1,"Start mit: 0    "
ini1:    inkey ta_dat                 'Tastatur einlesen
         wait 100
         if ta_dat<>"0" then goto ini1
         wait 100
         gosub grund
         let o_dat5 = $82              ' Split off 
         gosub aus
         let o_dat5 = $80              ' Lock off 
         gosub aus
         lcdwrite 1,1,"Split off   "
         lcdwrite 2,1,"Lock  off" 
         wait 2000
         lcdclear
         lcdwrite 1,1,"TRx:   ,    "
         gosub az1
         gosub grund
         gosub leer
         
         
main:    let spalte=5                 'Anfangsposition LCD
         let zeile=2
         let sp=8                     'Anfangsposition QRG-Ram
         let var=0
                                             
start:   gosub tast
         if ta_dat="1" then goto in1
         if ta_dat="2" then goto in2
         if ta_dat="3" then goto in3
         if ta_dat="4" then goto in4
         if ta_dat="5" then goto in5
         if ta_dat="6" then goto in6
         if ta_dat="7" then goto in7
         if ta_dat="8" then goto in8
         if ta_dat="9" then goto in9
         if ta_dat="0" then goto in0
         if ta_dat="A" then goto ina   'eine Position zurck
         if ta_dat="B" then goto inb   'Daten zum Gert
         goto start
         
in1:     let wert="1"
         gosub zeisp 
         let qrg(sp)=1
         gosub aw
         if spalte=15 then goto inb
         goto start
in2:     let wert="2"
         gosub zeisp
         let qrg(sp)=2
         gosub aw
         if spalte=15 then goto inb
         goto start
in3:     let wert="3"
         gosub zeisp        
         let qrg(sp)=3
         gosub aw
         if spalte=15 then goto inb
         goto start                  
in4:     let wert="4"
         gosub zeisp         
         let qrg(sp)=4
         gosub aw
         if spalte=15 then goto inb
         goto start         
in5:     let wert="5"
         gosub zeisp         
         let qrg(sp)=5
         gosub aw
         if spalte=15 then goto inb
         goto start         
in6:     let wert="6"
         gosub zeisp         
         let qrg(sp)=6
         gosub aw
         if spalte=15 then goto inb
         goto start         
in7:     let wert="7"
         gosub zeisp         
         let qrg(sp)=7
         gosub aw
         if spalte=15 then goto inb
         goto start         
in8:     let wert="8"
         gosub zeisp
         if spalte=5 then goto split 
         let qrg(sp)=8
         gosub aw
         if spalte=15 then goto inb
         goto start
in9:     let wert="9"
         gosub zeisp
         if spalte=5 then goto mode 
         let qrg(sp)=9
         gosub aw
         if spalte=15 then goto inb
         goto start         
in0:     let wert="0"
         gosub zeisp         
         let qrg(sp)=0
         gosub aw
         if spalte=15 then goto inb
         goto start  
                
ina:     inc sp                        'Zurck
         if sp=9 then let sp=8        
         let qrg(sp)=$f
         if sp=8 then let sp=7
         dec spalte
         if spalte=4 then goto ina1               
         if spalte=8 then let spalte=7
         let wert=" "
         gosub zeisp                                         
         locate t_ze,t_sp
         goto start                                        
         
ina1:    lcdwrite 2,1,"VFO A<->B mit  #"
ina2:    gosub tast
         if ta_dat="B" then goto inb3   'VFO - Wechsel: Daten zum Gert
         gosub az1
         goto main
   
inb:     gosub az2
         wait 500 
         lcdwrite 2,16," " 
         wait 1000 
         gosub az2            
         let o_dat5 =$01
inb1:    gosub dat_set
inb2:    wait 1000
         gosub az1
         goto main 
inb3:    gosub grund         
         let o_dat5=$81
         gosub aus
         goto inb2      

dat_set: let sp=8
         gosub rot                     'Nibbel selektieren
         let tmp2=qrg(8)
         let tmp1=qrg(7)
         let o_dat1=tmp2 or tmp1
         let sp=6
         gosub rot                     'Nibbel selektieren
         let tmp2=qrg(6)
         let tmp1=qrg(5)
         let o_dat2=tmp2 or tmp1
         let sp=4
         gosub rot                     'Nibbel selektieren
         let tmp2=qrg(4)
         let tmp1=qrg(3)
         let o_dat3=tmp2 or tmp1
         let sp=2
         gosub rot                     'Nibbel selektieren
         let tmp2=qrg(2)
         let tmp1=qrg(1)
         let o_dat4=tmp2 or tmp1
         gosub aus
         gosub grund                   'Speicher rckgesetzt
         gosub leer
         return                        

tast:    inkey ta_dat                 'Tastatur einlesen
         wait 100
         if ta_dat=0 then goto tast1   'keine Taste gedrckt ? 
         wait 150
         return
tast1:   inc var
         if var=50 then gosub stat
         goto tast

aw:      dec sp                        'Position setzen
         inc spalte
         if spalte=8 then let spalte=9
         return

leer:    for zahl=1 to 8               'Ausgabespeicher auf "0" stellen
         let qrg(zahl)=0
         next zahl
         return         
                
az1:     lcdwrite 2,1,"QRG:   ,        "
         locate 2,5
         return

az2:     lcdwrite 2,16,"#"
         return
 
rot:     let tmp0=qrg(sp)              'Position 4x nach links
         swap tmp0
         let qrg(sp)=tmp0
         return

aus:     set ra,1                      'Ruhepegel erzeugen --> GANZ WICHTIG !!!
         serout ra.1,4800,o_dat1,o_dat2,o_dat3,o_dat4,o_dat5                
         set ra,1                      'Ruhepegel erzeugen --> GANZ WICHTIG !!!
         return

grund:   let o_dat1 = 0
         let o_dat2 = 0
         let o_dat3 = 0
         let o_dat4 = 0
         let o_dat5 = 1                 
         return

zeisp:   let t_sp=spalte
         lcdwrite 2,t_sp,wert,#     '"wert" als ASCII ausgeben
         if t_sp=14 then lcdwrite t_ze,t_sp," "     
         return                        'unterdrcken der 6ten Stelle nach Komma
         
stat:    let var=0                     'var auf Null stellen
         gosub grund
         let o_dat5 = 3 
         gosub aus
         serin ra,0,4800,timeout=200,o_dat1,o_dat2,o_dat3,o_dat4,o_dat5 
         let trx=5                     'erste Stelle festlegen
	 let o_dat5=$0f and o_dat5
         let tmp0=o_dat1 and $f0       'hwt
         swap tmp0
         if tmp0=0 then goto stat2
         let tmp2=tmp0
         gosub stat1
         let tmp1=o_dat1 and $0f       'nwt
stat4:   let tmp2=tmp1
         gosub stat1
stat5:   let tmp0=o_dat2 and $f0       'hwt
         swap tmp0
         let tmp2=tmp0
         gosub stat1
         let tmp1=o_dat2 and $0f       'nwt
         let tmp2=tmp1
         gosub stat1
         let tmp0=o_dat3 and $f0       'hwt
         swap tmp0
         let tmp2=tmp0
         gosub stat1
         let tmp1=o_dat3 and $0f       'nwt
         let tmp2=tmp1
         gosub stat1
         if o_dat5=0 then lcdwrite 1,14,"LSB"
         if o_dat5=1 then lcdwrite 1,14,"USB"
         if o_dat5=2 then lcdwrite 1,14," CW"
         if o_dat5=3 then lcdwrite 1,14,"CWR"
         if o_dat5=4 then lcdwrite 1,14," AM"
         if o_dat5=6 then lcdwrite 1,14,"WFM"
         if o_dat5=8 then lcdwrite 1,14," FM"
         if o_dat5=$0a then lcdwrite 1,14,"DIG"
         if o_dat5=$0c then lcdwrite 1,14,"PKT"
         return
         
stat1:   let tmp2=$30 + tmp2             'Ausgabe OK!!!!!
         lcdwrite 1,trx,tmp2,#
         inc trx
         if trx=8 then let trx=9
         return

stat2:   lcdwrite 1,trx," "
         inc trx
         let tmp1=o_dat1 and $0f 
         if tmp1=0 then goto stat3
         goto stat4
stat3:   lcdwrite 1,trx," "
         inc trx
         goto stat5
        
split:   lcdwrite 2,1,"Split:1on/2off "
         gosub tast
         if ta_dat="1" then goto s_on
         if ta_dat="2" then goto s_of
         goto start
s_on:    gosub grund         
         let o_dat5 = 2 
         gosub aus
         lcdwrite 1,13,"*"
         gosub az1
         goto start
s_of:    gosub grund         
         let o_dat5 = $82 
         gosub aus
         lcdwrite 1,13," "
         gosub az1
         goto start

mode:    lcdwrite 2,1,"Mode:         "
         gosub grund
         let o_dat5 = 7 
         gosub tast
         if ta_dat="1" then goto cw
         if ta_dat="2" then goto lsb
         if ta_dat="3" then goto usb
         if ta_dat="4" then goto fm
         if ta_dat="5" then goto dig
         if ta_dat="6" then goto pkt
         if ta_dat="7" then goto am
         if ta_dat="8" then goto cwr
         goto cw1
cw:      let o_dat1 = 2
         lcdwrite 2,6," CW"
         gosub aus
         wait 1000
cw1:     gosub az1
         goto start
lsb:     let o_dat1 = 0
         lcdwrite 2,6,"LSB"
         gosub aus
         wait 1000
         gosub az1
         goto start
usb:     let o_dat1 = 1
         lcdwrite 2,6,"USB"
         gosub aus
         wait 1000
         gosub az1
         goto start
fm:      let o_dat1 = 8
         lcdwrite 2,6," FM"
         gosub aus
         wait 1000
         gosub az1
         goto start          
dig:     let o_dat1 = $0a
         lcdwrite 2,6,"DIG"
         gosub aus
         wait 1000
         gosub az1
         goto start
pkt:     let o_dat1 = $0c
         lcdwrite 2,6,"PKT"
         gosub aus
         wait 1000
         gosub az1
         goto start
am:      let o_dat1 = 4
         lcdwrite 2,6," AM"
         gosub aus
         wait 1000
         gosub az1
         goto start
cwr:     let o_dat1 = 3
         lcdwrite 2,6,"CWR"
         gosub aus
         wait 1000
         gosub az1
         goto start










